=== modified file 'bzrlib/fetch.py'
--- bzrlib/fetch.py	2010-09-17 04:35:23 +0000
+++ bzrlib/fetch.py	2010-12-14 09:21:14 +0000
@@ -125,9 +125,6 @@
             pb.update("Inserting stream")
             resume_tokens, missing_keys = self.sink.insert_stream(
                 stream, from_format, [])
-            if self.to_repository._fallback_repositories:
-                missing_keys.update(
-                    self._parent_inventories(search.get_keys()))
             if missing_keys:
                 pb.update("Missing keys")
                 stream = source.get_stream_for_missing_keys(missing_keys)
@@ -163,18 +160,6 @@
             self.from_repository, self._last_revision,
             find_ghosts=self.find_ghosts)
 
-    def _parent_inventories(self, revision_ids):
-        # Find all the parent revisions referenced by the stream, but
-        # not present in the stream, and make sure we send their
-        # inventories.
-        parent_maps = self.to_repository.get_parent_map(revision_ids)
-        parents = set()
-        map(parents.update, parent_maps.itervalues())
-        parents.discard(NULL_REVISION)
-        parents.difference_update(revision_ids)
-        missing_keys = set(('inventories', rev_id) for rev_id in parents)
-        return missing_keys
-
 
 class Inter1and2Helper(object):
     """Helper for operations that convert data from model 1 and 2

=== modified file 'bzrlib/tests/blackbox/test_push.py'
--- bzrlib/tests/blackbox/test_push.py	2010-12-09 04:26:53 +0000
+++ bzrlib/tests/blackbox/test_push.py	2010-12-14 09:21:14 +0000
@@ -231,7 +231,7 @@
         # being too low. If rpc_count increases, more network roundtrips have
         # become necessary for this use case. Please do not adjust this number
         # upwards without agreement from bzr's network support maintainers.
-        self.assertLength(14, self.hpss_calls)
+        self.assertLength(13, self.hpss_calls)
         remote = branch.Branch.open('public')
         self.assertEndsWith(remote.get_stacked_on_url(), '/parent')
 

=== modified file 'doc/en/release-notes/bzr-2.3.txt'
--- doc/en/release-notes/bzr-2.3.txt	2010-12-09 15:04:24 +0000
+++ doc/en/release-notes/bzr-2.3.txt	2010-12-14 23:00:51 +0000
@@ -26,6 +26,11 @@
 .. Improvements to existing commands, especially improved performance 
    or memory usage, or better results.
 
+* A redundant parent inventories calculation was removed from
+  ``fetch.py``, as ``Repository.insert_stream`` already reports any
+  missing inventories.  This removes at least one network roundtrip when
+  pushing to a stacked branch.  (Andrew Bennetts)
+
 * ``bzr resolve`` now accepts ``--take-this`` and ``--take-other`` actions
   for text conflicts. This *replace* the whole file with the content
   designated by the action. This will *ignore* all differences that would

=== modified file 'doc/en/whats-new/whats-new-in-2.3.txt'
--- doc/en/whats-new/whats-new-in-2.3.txt	2010-12-03 07:51:28 +0000
+++ doc/en/whats-new/whats-new-in-2.3.txt	2010-12-14 09:33:53 +0000
@@ -69,6 +69,9 @@
 * ``bzr send`` uses less memory.
   (John Arbash Meinel, #614576)
 
+* Fetches involving stacked branches and branches with tags are now faster.
+  Some redundant network reads were removed.  (Andrew Bennetts)
+
 * Inventory entries now consume less memory (on 32-bit Ubuntu file entries
   have dropped from 68 bytes to 40, and directory entries from 120 bytes
   to 48).  This affects most operations, and depending on the size of the

